function [ R, C ] = HZ2ptam( trans1, trans2 )
% THIS INVERTS THE TRANSFORM AND RE-EXTRACTS R,T
%
%For 1 input, assumed to be a 4 by 4 transformation matrix
%for 2 inputs assumed to be rotation and translation.
%
%goes from convention where R is rotation from camera to
%world and t is translation from camera to world, applied in that order
%to PTAM convention where t is translation from world to camera, and R is
%rotation from world to camera

if nargin==1
    error('not implemented');
elseif nargin==2
    R=trans1';
    C=-trans1'*trans2;
else
    error('wrong number of inputs');
end

end

