function orthm = ang2orth(ang) 
%Assumes that the order is roll, pitch, yaw
%Z then X then Y, which means     v = RY * (RX * (RZ * v))
	sa = sin(ang(1)); ca = cos(ang(1)); 
	sb = sin(ang(2)); cb = cos(ang(2)); 
	sc = sin(ang(3)); cc = cos(ang(3)); 

    %roll
	ra = [  ca, -sa,  0; ... 
		    sa,  ca,  0; ... 
			 0,   0,  1]; 
    %pitch
	rb = [  1,   0,   0; ... 
			0,   cb,-sb;... 
			0,   sb, cb]; 
    %yaw
	rc = [  cc,  0,  sc; ... 
			 0,  1,  0; ... 
		   -sc,  0,  cc]; 
       
	orthm = rc*rb*ra; 
end