function [ output ] = create_neighbourhood_stack( data, num_neighbours)
%assumes dim1 and dim2 are the ones to find neighbours in
%currently only looks at 4-neighbourhood and 8-neighbourhood
%

    if ~num_neighbours==4 && ~num_neighbours==8
        error('Unrecognised num_neighbours %i\n',num_neighbours);
    end
    if ~ndims(data)==2
        error('Not implemented for arrays with more than 2 dimensions');
    end
    
    output = nan([size(data) num_neighbours+1]);
    out_idx=1;
    
    [width,height]=size(data);

    for x_off=-1:1
        switch(x_off)
            case -2
                new_x=[1,1,1:width-2];
            case -1
                new_x=[1,1:width-1];
            case 0
                new_x=1:width;
            case 1
                new_x=[2:width,width];
            case 2
                new_x=[3:width,width,width];
        end
        for y_off=-1:1
            switch(y_off)
                case -2
                    new_y=[1,1,1:height-2];
                case -1
                    new_y=[1,1:height-1];
                case 0
                    new_y=1:height;
                case 1
                    new_y=[2:height,height];
                case 2
                    new_y=[3:height,height,height];
            end
            
            %4 neighbourhood
            if x_off==0 || y_off==0
                output(:,:,out_idx) = data(new_y,new_x,:);  
                out_idx=out_idx+1;
            elseif num_neighbours==8
                output(:,:,out_idx) = data(new_y,new_x,:);  
                out_idx=out_idx+1;  
            end
        end
    end
end

