function quat = orth2quat( m )
% rotation matrix to Quaternion 
% order x,y,z,w
quat=zeros(4,1);
tr = trace(m);
if tr > 0
    s = 0.5 / sqrt(tr + 1.0);
    quat(4) = 0.25 / s;
    quat(1) = ( m(3,2) - m(2,3) ) * s;
    quat(2) = ( m(1,3) - m(3,1) ) * s;
    quat(3) = ( m(2,1) - m(1,2) ) * s;
else

    if ( m(1,1) > m(2,2) && m(1,1) > m(3,3) )
            s = 2.0 * sqrt( 1.0 + m(1,1) - m(2,2) - m(3,3));
            quat(4) = (m(3,2) - m(2,3) ) / s;
            quat(1) = 0.25 * s;
            quat(2) = (m(1,2) + m(2,1) ) / s;
            quat(3) = (m(1,3) + m(3,1) ) / s;
    elseif (m(2,2) > m(3,3))
            s = 2.0 * sqrt( 1.0 + m(2,2) - m(1,1) - m(3,3));
            quat(4) = (m(1,3) - m(3,1) ) / s;
            quat(1) = (m(1,2) + m(2,1) ) / s;
            quat(2) = 0.25 * s;
            quat(3) = (m(2,3) + m(3,2) ) / s;
    else
            s = 2.0 * sqrt( 1.0 + m(3,3) - m(1,1) - m(2,2) );
            quat(4) = (m(2,1) - m(1,2) ) / s;
            quat(1) = (m(1,3) + m(3,1) ) / s;
            quat(2) = (m(2,3) + m(3,2) ) / s;
            quat(3) = 0.25 * s;
    end
end

        
end

