function [ cam ] = p2cam( P )
    %convert a projection matrix (or cell array of them) to a
    %camera structure (or cell array of them)
    
    if iscell(P)
        cam=cell(numel(P),1);
        for i=1:numel(P)
            cam{i} = p2cam_single(P{i});
        end
    else
        cam = p2cam_single(P);
    end    
end


function [ cam ] = p2cam_single( P )    
    cam.P = P;
    cam.f=1;
    [cam.K,cam.R,cam.C] = decomposeP(P);
end
