function [R, t] = pnp_update_mex_wrapper(cam ,point_subset3D, point_subset2D,stopping_criteria,rotation_type)
    switch rotation_type
    	case {-2,0,10}
    		r=orth2rv(cam.R);
    	case {-3,1,11}
    		r=orth2aa(cam.R);
    	case {-1,2,3,12}
    		r=orth2quat(cam.R)';
		otherwise
			error('Unknown rotation type!');
    end
    
    cam_params=[r,cam.C',cam.K(1,1),cam.K(1,3),cam.K(2,3)];
    result=pnp_update_mex(cam_params, point_subset3D, point_subset2D, stopping_criteria,rotation_type);
	
	switch rotation_type            
    	case {-2,0,10}
    		R=rv2orth(result(1:3));
    		t=result(4:6)';
    	case {-3,1,11}
	    	R=aa2orth(result(1:4));
	    	t=result(5:7)';
    	case {-1,2,3,12}
    		R=quat2orth(result(1:4));
	    	t=result(5:7)';
		otherwise
			error('Unknown rotation type!');
	end
end
