function rot_mat = quat2orth( quat )
% Quaternion to rotation matrix
% order x,y,z,w (doesn't need to be a unit quaternion)


% aerospace toolbox has quat2angle, but I don't
% orth = ang2orth(quat2angle(quat));

sqx = quat(1)*quat(1);
sqy = quat(2)*quat(2);
sqz = quat(3)*quat(3);
sqw = quat(4)*quat(4);

rot_mat=zeros(3,3);

invs = 1 / (sqx + sqy + sqz + sqw);
rot_mat(1,1) = ( sqx - sqy - sqz + sqw) * invs;
rot_mat(2,2) = (-sqx + sqy - sqz + sqw) * invs;
rot_mat(3,3) = (-sqx - sqy + sqz + sqw) * invs;

tmp1 = quat(1)*quat(2);
tmp2 = quat(3)*quat(4);
rot_mat(2,1) = 2.0 * (tmp1 + tmp2) * invs;
rot_mat(1,2) = 2.0 * (tmp1 - tmp2) * invs;

tmp1 = quat(1)*quat(3);
tmp2 = quat(2)*quat(4);
rot_mat(3,1) = 2.0 * (tmp1 - tmp2) * invs;
rot_mat(1,3) = 2.0 * (tmp1 + tmp2) * invs;

tmp1 = quat(2)*quat(3);
tmp2 = quat(1)*quat(4);
rot_mat(3,2) = 2.0 * (tmp1 + tmp2) * invs;
rot_mat(2,3) = 2.0 * (tmp1 - tmp2) * invs;

end

