(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   1816326,      45255]
NotebookOptionsPosition[   1815257,      45219]
NotebookOutlinePosition[   1816210,      45250]
CellTagsIndexPosition[   1816167,      45247]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Rotation vector rotation hessian", "Section",
 CellChangeTimes->{{3.4529660967377443`*^9, 3.452966119824486*^9}, {
  3.6401072856196375`*^9, 3.640107291842189*^9}, {3.7207903459047546`*^9, 
  3.7207903490737543`*^9}, {3.7207903853677545`*^9, 3.7207903954887543`*^9}, {
  3.7207916533487544`*^9, 3.7207916550517545`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"r", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"r1", ",", "r2", ",", "r3"}], "}"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rm", "=", 
   RowBox[{"Sqrt", "[", 
    RowBox[{
     RowBox[{"r1", "*", "r1"}], " ", "+", " ", 
     RowBox[{"r2", "*", "r2"}], " ", "+", " ", 
     RowBox[{"r3", "*", "r3"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"s", "=", 
   RowBox[{"Sin", "[", "rm", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"co", "=", 
   RowBox[{"Cos", "[", "rm", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"t", "=", 
   RowBox[{"1", "-", "co"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"r1", "/", "rm"}], ",", 
     RowBox[{"r2", "/", "rm"}], ",", 
     RowBox[{"r3", "/", "rm"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"x", "=", 
   RowBox[{"n", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"y", "=", 
   RowBox[{"n", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"z", "=", 
   RowBox[{"n", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"R", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"t", "*", "x", "*", "x"}], "+", "co"}], ",", 
       RowBox[{
        RowBox[{"t", "*", "x", "*", "y"}], "-", 
        RowBox[{"s", "*", "z"}]}], ",", 
       RowBox[{
        RowBox[{"t", "*", "x", "*", "z"}], "+", 
        RowBox[{"s", "*", "y"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"t", "*", "x", "*", "y"}], "+", 
        RowBox[{"s", "*", "z"}]}], ",", 
       RowBox[{
        RowBox[{"t", "*", "y", "*", "y"}], "+", "co"}], ",", 
       RowBox[{
        RowBox[{"t", "*", "y", "*", "z"}], "-", 
        RowBox[{"s", "*", "x"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"t", "*", "x", "*", "z"}], "-", 
        RowBox[{"s", "*", "y"}]}], ",", 
       RowBox[{
        RowBox[{"t", "*", "y", "*", "z"}], "+", 
        RowBox[{"s", "*", "x"}]}], ",", 
       RowBox[{
        RowBox[{"t", "*", "z", "*", "z"}], "+", "co"}]}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"c", "=", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"C1", ",", "C2", ",", "C3"}], "}"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"**", "**", "**", "**", "**", "**", "**"}], "*", " ", "NOTE", " ",
     "NOTE", " ", "NOTE", " ", 
    RowBox[{"NOTE", "**", "**", "**", "**", "**", "**", "**", "**"}]}], 
   "******)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"changed", " ", "to", " ", "simons", " ", "notation"}], ",", " ", 
    
    RowBox[{
    "where", " ", "projection", " ", "matrix", " ", "formed", " ", "with", 
     " ", "inverse", " ", "rotation"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"P", "=", 
   RowBox[{
    RowBox[{"Transpose", "[", "R", "]"}], ".", 
    RowBox[{"Transpose", "[", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"IdentityMatrix", "[", "3", "]"}], ",", 
       RowBox[{"-", "c"}]}], "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"X", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", "X1", "}"}], ",", 
     RowBox[{"{", "X2", "}"}], ",", 
     RowBox[{"{", "X3", "}"}], ",", 
     RowBox[{"{", "1", "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"xp", "=", 
   RowBox[{"P", ".", "X"}]}], " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"u", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"xp", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "/", 
      RowBox[{"xp", "[", 
       RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"v", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"xp", "[", 
       RowBox[{"[", "2", "]"}], "]"}], "/", 
      RowBox[{"xp", "[", 
       RowBox[{"[", "3", "]"}], "]"}]}], ")"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"du", " ", "=", " ", 
  RowBox[{"D", "[", 
   RowBox[{"u", ",", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"r1", ",", "r2", ",", "r3"}], "}"}], ",", "2"}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dv", " ", "=", " ", 
   RowBox[{"D", "[", 
    RowBox[{"v", ",", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"r1", ",", "r2", ",", "r3"}], "}"}], ",", "2"}], "}"}]}], 
    "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.452437981767764*^9, 3.452437996995854*^9}, {
   3.4524406489812927`*^9, 3.452440652067245*^9}, {3.452446782440468*^9, 
   3.452446787270488*^9}, {3.5787274473364534`*^9, 3.5787274726096535`*^9}, {
   3.5787294255289087`*^9, 3.57872944055081*^9}, {3.5787305228958435`*^9, 
   3.5787305294546742`*^9}, {3.578732009207023*^9, 3.578732031206808*^9}, {
   3.5787342739027576`*^9, 3.578734287534484*^9}, 3.578734333518306*^9, {
   3.5787368529892907`*^9, 3.5787368543324604`*^9}, {3.585898412146451*^9, 
   3.5858985230576377`*^9}, {3.5858986549695096`*^9, 3.585898667342092*^9}, 
   3.603624835906171*^9, {3.603698394384819*^9, 3.6036983989490805`*^9}, {
   3.603698430710905*^9, 3.603698437173276*^9}, 3.6393257758046207`*^9, 
   3.639387451781255*^9, {3.6393875290387163`*^9, 3.6393876846047006`*^9}, {
   3.6393877345455847`*^9, 3.6393878052696695`*^9}, {3.639387872483551*^9, 
   3.6393879207743397`*^9}, {3.6393879933025284`*^9, 
   3.6393879957796717`*^9}, {3.639388257474785*^9, 3.6393882670683393`*^9}, {
   3.6393883178542724`*^9, 3.639388468746987*^9}, {3.6393890253701324`*^9, 
   3.639389090003866*^9}, {3.639389124226842*^9, 3.639389161524996*^9}, {
   3.6393893075704308`*^9, 3.639389322605299*^9}, {3.639389402857933*^9, 
   3.6393894828995557`*^9}, {3.639389516892519*^9, 3.6393895369536777`*^9}, {
   3.63990591996638*^9, 3.6399059254836917`*^9}, {3.639908274685561*^9, 
   3.639908289105375*^9}, {3.6399903571878195`*^9, 3.639990361018036*^9}, {
   3.640107541419482*^9, 3.640107978382841*^9}, {3.640108013870723*^9, 
   3.640108033632083*^9}, {3.640108065250688*^9, 3.6401080689798164`*^9}, {
   3.6401081298165035`*^9, 3.640108395068584*^9}, {3.6401085381484003`*^9, 
   3.6401085383635225`*^9}, {3.6401085950778975`*^9, 3.640108791100794*^9}, {
   3.640109003679947*^9, 3.640109300380311*^9}, {3.6401093403381195`*^9, 
   3.6401094357755985`*^9}, {3.6401110843108025`*^9, 3.64011108441286*^9}, {
   3.6401111166392555`*^9, 3.6401111757640057`*^9}, {3.6401112564120426`*^9, 
   3.64011125859629*^9}, {3.6401113010375233`*^9, 3.6401113411574163`*^9}, {
   3.6401113719139743`*^9, 3.6401113959617014`*^9}, {3.6401114332589912`*^9, 
   3.640111456046999*^9}, {3.6401115053051176`*^9, 3.640111819812648*^9}, {
   3.640111906020857*^9, 3.640111958155618*^9}, {3.64011215967365*^9, 
   3.6401121598057256`*^9}, {3.6401122585610967`*^9, 
   3.6401122716405635`*^9}, {3.6401125329026995`*^9, 
   3.6401125430214753`*^9}, {3.6401125746295185`*^9, 3.640112582582057*^9}, {
   3.640112619471114*^9, 3.640112858635637*^9}, {3.6401128901536283`*^9, 
   3.640113082933673*^9}, {3.640113125251829*^9, 3.640113139040699*^9}, {
   3.6401131774646335`*^9, 3.640113253001752*^9}, {3.6401132927064166`*^9, 
   3.6401134460969753`*^9}, {3.640113486254899*^9, 3.64011353861679*^9}, {
   3.6401136330236793`*^9, 3.6401139575669374`*^9}, {3.6401139931492486`*^9, 
   3.6401141868728323`*^9}, {3.6401142665232983`*^9, 3.640114456953001*^9}, {
   3.640114488012731*^9, 3.640114553737248*^9}, {3.640114614422889*^9, 
   3.640115044608452*^9}, {3.6401150815365305`*^9, 3.640115131110831*^9}, {
   3.6401151961839757`*^9, 3.6401152887207975`*^9}, {3.6401154023746743`*^9, 
   3.640115433778601*^9}, {3.6401154789463844`*^9, 3.640115688560033*^9}, {
   3.6401523196648326`*^9, 3.6401523462210083`*^9}, {3.6401523908798103`*^9, 
   3.6401523957955503`*^9}, {3.6401526263351383`*^9, 
   3.6401526268595495`*^9}, {3.640152738379173*^9, 3.6401527816677914`*^9}, {
   3.6401530470411425`*^9, 3.640153128471808*^9}, {3.640154254227536*^9, 
   3.640154278789012*^9}, {3.640154763962309*^9, 3.6401547767753186`*^9}, {
   3.64015481354348*^9, 3.640154815574479*^9}, {3.640155091502006*^9, 
   3.6401551041366353`*^9}, 3.640155262773436*^9, 3.640155502520983*^9, 
   3.640155594585964*^9, 3.640155666929967*^9, {3.6401557625353565`*^9, 
   3.640155768552517*^9}, {3.6401558052084184`*^9, 3.6401558203277082`*^9}, {
   3.648378207175408*^9, 3.648378213215751*^9}, {3.6484756641544094`*^9, 
   3.648475673467939*^9}, {3.6484758375192537`*^9, 3.648475856860352*^9}, {
   3.6484766323943863`*^9, 3.648476640668856*^9}, {3.6484766864884577`*^9, 
   3.6484767123009233`*^9}, {3.6484807167532945`*^9, 
   3.6484807343272924`*^9}, {3.648889266588815*^9, 3.6488892698510003`*^9}, 
   3.6488893544068007`*^9, {3.648889506837456*^9, 3.64888951131071*^9}, {
   3.6488896576620207`*^9, 3.6488897225447035`*^9}, 3.6488897566026373`*^9, {
   3.6488898067764864`*^9, 3.6488898584384203`*^9}, {3.648889916099694*^9, 
   3.648890014345272*^9}, {3.6488900688263655`*^9, 3.6488902676166525`*^9}, {
   3.648975081493044*^9, 3.6489751338110485`*^9}, {3.6489751805607333`*^9, 
   3.648975191529363*^9}, {3.648975417836359*^9, 3.64897542271764*^9}, 
   3.648978110758008*^9, {3.6489785155127125`*^9, 3.6489785246722383`*^9}, 
   3.7203550903012404`*^9, 3.7203551378752403`*^9, {3.72035523958224*^9, 
   3.7203552508102407`*^9}, {3.7203639466032405`*^9, 
   3.7203640626052403`*^9}, {3.7203641491682405`*^9, 3.72036415481324*^9}, {
   3.7203641862372403`*^9, 3.7203641882972403`*^9}, {3.7203651044212403`*^9, 
   3.7203651174802403`*^9}, {3.7203670057932405`*^9, 
   3.7203670072822404`*^9}, {3.7204309648432407`*^9, 
   3.7204309670552406`*^9}, {3.7204311383892403`*^9, 3.72043115194324*^9}, {
   3.720790076936754*^9, 3.7207901577237544`*^9}, {3.7207903026407547`*^9, 
   3.7207903054677544`*^9}, {3.720791793497754*^9, 3.7207918218487544`*^9}, {
   3.7207918617427545`*^9, 3.7207919185477543`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "C2"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r2", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r2", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r3", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
             RowBox[{"X2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r2", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r2", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r3", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
             RowBox[{"C3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
             RowBox[{"X3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
             RowBox[{"C1", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "3"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"2", " ", "r1", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "3"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X1", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "3"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"2", " ", "r1", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "3"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "C1"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
             RowBox[{"X1", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
             RowBox[{"C2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
             RowBox[{"C3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", 
                   SuperscriptBox["r3", "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", 
                   SuperscriptBox["r3", "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}],
          "/", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "C3"}], " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               RowBox[{"Cos", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
            RowBox[{"X3", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               RowBox[{"Cos", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
            RowBox[{"C2", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r1", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
            RowBox[{"X2", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r1", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
            RowBox[{"C1", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r1", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r2", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
            RowBox[{"X1", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r1", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r2", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
        ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C3"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"6", " ", "r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"6", " ", "r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"6", " ", "r1", " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r1", "2"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r1", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"6", " ", "r1", " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r1", "2"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r1", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "4"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"10", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "4"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "4"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"6", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"Sin", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "4"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"10", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "4"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "4"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"6", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"Sin", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C3"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
         RowBox[{"C1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "C1"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  SuperscriptBox["r1", "2"], " ", "r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{"r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r1", " ", "r2", " ", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r1", " ", "r2", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "+", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
            RowBox[{"X1", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  SuperscriptBox["r1", "2"], " ", "r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{"r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r1", " ", "r2", " ", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r1", " ", "r2", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "+", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
            RowBox[{"C2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], " ", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "+", 
               FractionBox[
                RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "-", 
               FractionBox[
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
            RowBox[{"X2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], " ", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "+", 
               FractionBox[
                RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "-", 
               FractionBox[
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
            RowBox[{"C3", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", "r1", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{"r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "-", 
               FractionBox[
                RowBox[{"r1", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
            RowBox[{"X3", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", "r1", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{"r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "-", 
               FractionBox[
                RowBox[{"r1", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"], 
         " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "3"]}], 
      "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r1", "3"], " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"6", " ", "r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "3"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r1", "3"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r1", "3"], " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"6", " ", "r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "3"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r1", "3"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}]}], 
     ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "C1"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
             RowBox[{"X1", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
             RowBox[{"C2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
             RowBox[{"C3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", 
                   SuperscriptBox["r3", "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", 
                   SuperscriptBox["r3", "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "C2"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", 
                   SuperscriptBox["r2", "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r2", " ", "r3", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
             RowBox[{"X2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", 
                   SuperscriptBox["r2", "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r2", " ", "r3", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
             RowBox[{"C3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
             RowBox[{"C1", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r2", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X1", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r2", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}],
          "/", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "C3"}], " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               RowBox[{"Cos", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
            RowBox[{"X3", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               RowBox[{"Cos", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
            RowBox[{"C2", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r1", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
            RowBox[{"X2", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r1", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
            RowBox[{"C1", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r1", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r2", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
            RowBox[{"X1", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r1", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r2", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
        ")"}]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C1"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"4", " ", "r1", " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"4", " ", "r1", " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"1", "-", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"1", "-", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C3"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
         RowBox[{"C1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "3"]}], 
      "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C3"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}]}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C1"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"4", " ", "r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"4", " ", "r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"1", "-", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"1", "-", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C3"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
         RowBox[{"C1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C3"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C3"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"4", " ", "r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"4", " ", "r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "3"]}]}]}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "C1"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
             RowBox[{"X1", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
             RowBox[{"C2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
             RowBox[{"C3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", 
                   SuperscriptBox["r3", "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", 
                   SuperscriptBox["r3", "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "C2"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", 
                   SuperscriptBox["r2", "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r2", " ", "r3", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
             RowBox[{"X2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", 
                   SuperscriptBox["r2", "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r2", " ", "r3", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
             RowBox[{"C3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
             RowBox[{"C1", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r2", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X1", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r2", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}],
          "/", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "C3"}], " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               RowBox[{"Cos", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
            RowBox[{"X3", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               RowBox[{"Cos", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
            RowBox[{"C2", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r1", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
            RowBox[{"X2", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r1", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
            RowBox[{"C1", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r1", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r2", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
            RowBox[{"X1", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r1", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r2", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
        ")"}]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C1"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"4", " ", "r1", " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"4", " ", "r1", " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "3"], " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"1", "-", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"1", "-", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C3"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
         RowBox[{"C1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "3"]}], 
      "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C3"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}]}], 
     ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "C2"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", 
                   SuperscriptBox["r2", "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r2", " ", "r3", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
             RowBox[{"X2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", 
                   SuperscriptBox["r2", "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r2", " ", "r3", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", 
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
             RowBox[{"C3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
             RowBox[{"C1", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r2", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X1", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r1", "2"], " ", "r2", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "C2"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r2", "2"], " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
             RowBox[{"X2", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", 
                   SuperscriptBox["r2", "2"], " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "-", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
             RowBox[{"C1", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X1", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "-", 
                FractionBox[
                 RowBox[{
                  SuperscriptBox["r2", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "+", 
                FractionBox[
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
             RowBox[{"C3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r2", " ", 
                   SuperscriptBox["r3", "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r2", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
             RowBox[{"X3", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", " ", "r2", " ", 
                   SuperscriptBox["r3", "2"], " ", 
                   RowBox[{"(", 
                    RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
                FractionBox[
                 RowBox[{"r2", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], 
                  RowBox[{"3", "/", "2"}]]], "-", 
                FractionBox[
                 RowBox[{"r2", " ", 
                  RowBox[{"Sin", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}],
          "/", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "C3"}], " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               RowBox[{"Cos", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
            RowBox[{"X3", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               RowBox[{"Cos", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
            RowBox[{"C2", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r1", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
            RowBox[{"X2", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r1", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
            RowBox[{"C1", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r1", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r2", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
            RowBox[{"X1", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox[
                RowBox[{"r1", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r2", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
        ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C3"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "3"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "3"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "3"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "3"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "3"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "3"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", 
              SuperscriptBox["r2", "3"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"6", " ", "r1", " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r2", "3"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", 
              SuperscriptBox["r2", "3"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", 
              SuperscriptBox["r2", "3"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"6", " ", "r1", " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r2", "3"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", 
              SuperscriptBox["r2", "3"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"Sin", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"Sin", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C3"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
         RowBox[{"C1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "C2"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  SuperscriptBox["r2", "2"], " ", "r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{"r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r1", " ", "r2", " ", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r1", " ", "r2", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "+", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
            RowBox[{"X2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  SuperscriptBox["r2", "2"], " ", "r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{"r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r1", " ", "r2", " ", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r1", " ", "r2", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "+", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
            RowBox[{"C1", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["r2", "2"], " ", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["r2", "2"], " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "+", 
               FractionBox[
                RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "+", 
               FractionBox[
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
            RowBox[{"X1", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["r2", "2"], " ", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["r2", "2"], " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "+", 
               FractionBox[
                RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "+", 
               FractionBox[
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
            RowBox[{"C3", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", "r2", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{"r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "-", 
               FractionBox[
                RowBox[{"r2", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
            RowBox[{"X3", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", "r2", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{"r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "-", 
               FractionBox[
                RowBox[{"r2", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"], 
         " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "3"]}], 
      "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r2", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r2", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r2", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r2", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r2", "3"], " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"6", " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "3"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r2", "3"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r2", "3"], " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"6", " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "3"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r2", "3"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}]}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C1"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r1", " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r1", " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C3"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
         RowBox[{"C1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C3"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r2", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r2", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C3"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"4", " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"4", " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "3"]}]}]}],
     "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C1"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"4", " ", "r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"4", " ", "r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "3"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"1", "-", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"1", "-", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C3"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
         RowBox[{"C1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C3"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C3"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"4", " ", "r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"4", " ", "r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r1", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "3"]}]}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C1"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", "r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r1", " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r1", " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", 
              SuperscriptBox["r2", "2"], " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C3"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
         RowBox[{"C1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C3"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r2", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r2", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C3"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"4", " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"4", " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", "r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", 
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r2", "2"], " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r2", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r2", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "3"]}]}], 
     ",", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C3"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", 
              SuperscriptBox["r3", "3"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"6", " ", "r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r3", "3"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", 
              SuperscriptBox["r3", "3"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", 
              SuperscriptBox["r3", "3"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"6", " ", "r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", 
              SuperscriptBox["r3", "3"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", 
              SuperscriptBox["r3", "3"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r1", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r1", " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r3", "3"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r3", "3"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "3"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", "r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", "r1", " ", "r2", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r3", "3"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{"3", " ", "r3", " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", "r1", " ", "r2", " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"3", " ", 
              SuperscriptBox["r3", "3"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{"r1", " ", "r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"3", " ", "r3", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "3"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
         RowBox[{"C1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"Sin", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"8", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
            FractionBox[
             RowBox[{"2", " ", 
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"5", " ", 
              SuperscriptBox["r1", "2"], " ", 
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"5", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r1", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "+", 
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}], ")"}], 
              RowBox[{"3", "/", "2"}]]], "-", 
            FractionBox[
             RowBox[{"Sin", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "C3"}], " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
         RowBox[{"X3", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{
              SuperscriptBox["r3", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            RowBox[{"Cos", "[", 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
         RowBox[{"C2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X2", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r2", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "-", 
            FractionBox[
             RowBox[{"r1", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
         RowBox[{"C1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
         RowBox[{"X1", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             RowBox[{"r1", " ", "r3", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
             RowBox[{
              SuperscriptBox["r1", "2"], "+", 
              SuperscriptBox["r2", "2"], "+", 
              SuperscriptBox["r3", "2"]}]], "+", 
            FractionBox[
             RowBox[{"r2", " ", 
              RowBox[{"Sin", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], 
             SqrtBox[
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C3"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", "r2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r1", "2"], " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", "r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", " ", 
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
              FractionBox[
               RowBox[{"2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C2"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"6", " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"6", " ", "r2", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r2", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"6", " ", "r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", "r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"6", " ", "r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"5", " ", "r1", " ", 
                SuperscriptBox["r3", "3"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"3", " ", "r1", " ", "r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r3", "4"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"10", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "4"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r3", "4"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"6", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"8", " ", 
                SuperscriptBox["r3", "4"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "3"]], "-", 
              FractionBox[
               RowBox[{"10", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "+", 
              FractionBox[
               RowBox[{"2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "4"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], "2"]], "-", 
              FractionBox[
               RowBox[{
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Cos", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"5", " ", 
                SuperscriptBox["r3", "4"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"5", "/", "2"}]]], "+", 
              FractionBox[
               RowBox[{"6", " ", 
                SuperscriptBox["r3", "2"], " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}], ")"}], 
                RowBox[{"3", "/", "2"}]]], "-", 
              FractionBox[
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"]}], 
      "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "C1"}], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", "r1", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{"r1", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r2", " ", "r3", " ", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r2", " ", "r3", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "+", 
               FractionBox[
                RowBox[{"r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
            RowBox[{"X1", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", "r1", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{"r1", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r2", " ", "r3", " ", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r2", " ", "r3", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "+", 
               FractionBox[
                RowBox[{"r1", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
            RowBox[{"C2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", "r2", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{"r2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r1", " ", "r3", " ", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r1", " ", "r3", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "+", 
               FractionBox[
                RowBox[{"r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]]}], ")"}]}], "+", 
            RowBox[{"X2", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", "r2", " ", 
                  SuperscriptBox["r3", "2"], " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{"r2", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "-", 
               FractionBox[
                RowBox[{"r1", " ", "r3", " ", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{"r1", " ", "r3", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "+", 
               FractionBox[
                RowBox[{"r2", " ", 
                 SuperscriptBox["r3", "2"], " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]]}], ")"}]}], "-", 
            RowBox[{"C3", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  SuperscriptBox["r3", "3"], " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{"2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "-", 
               FractionBox[
                RowBox[{"r3", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
            RowBox[{"X3", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{"2", " ", 
                  SuperscriptBox["r3", "3"], " ", 
                  RowBox[{"(", 
                   RowBox[{"1", "-", 
                    RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}], ")"}], "2"]]}], "+", 
               FractionBox[
                RowBox[{"2", " ", "r3", " ", 
                 RowBox[{"(", 
                  RowBox[{"1", "-", 
                   RowBox[{"Cos", "[", 
                    SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "+", 
               FractionBox[
                RowBox[{
                 SuperscriptBox["r3", "3"], " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}], ")"}], 
                 RowBox[{"3", "/", "2"}]]], "-", 
               FractionBox[
                RowBox[{"r3", " ", 
                 RowBox[{"Sin", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "2"], 
         " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "C1"}], " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
           RowBox[{"X1", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{
                SuperscriptBox["r1", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              RowBox[{"Cos", "[", 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
           RowBox[{"C3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X3", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r3", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "-", 
              FractionBox[
               RowBox[{"r2", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
           RowBox[{"C2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
           RowBox[{"X2", " ", 
            RowBox[{"(", 
             RowBox[{
              FractionBox[
               RowBox[{"r1", " ", "r2", " ", 
                RowBox[{"(", 
                 RowBox[{"1", "-", 
                  RowBox[{"Cos", "[", 
                   SqrtBox[
                    RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "+", 
              FractionBox[
               RowBox[{"r3", " ", 
                RowBox[{"Sin", "[", 
                 SqrtBox[
                  RowBox[{
                   SuperscriptBox["r1", "2"], "+", 
                   SuperscriptBox["r2", "2"], "+", 
                   SuperscriptBox["r3", "2"]}]], "]"}]}], 
               SqrtBox[
                RowBox[{
                 SuperscriptBox["r1", "2"], "+", 
                 SuperscriptBox["r2", "2"], "+", 
                 SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}]}], ")"}], 
       "/", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "C3"}], " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "+", 
          RowBox[{"X3", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{
               SuperscriptBox["r3", "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             RowBox[{"Cos", "[", 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], "-", 
          RowBox[{"C2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X2", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r2", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "-", 
             FractionBox[
              RowBox[{"r1", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "-", 
          RowBox[{"C1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}], "+", 
          RowBox[{"X1", " ", 
           RowBox[{"(", 
            RowBox[{
             FractionBox[
              RowBox[{"r1", " ", "r3", " ", 
               RowBox[{"(", 
                RowBox[{"1", "-", 
                 RowBox[{"Cos", "[", 
                  SqrtBox[
                   RowBox[{
                    SuperscriptBox["r1", "2"], "+", 
                    SuperscriptBox["r2", "2"], "+", 
                    SuperscriptBox["r3", "2"]}]], "]"}]}], ")"}]}], 
              RowBox[{
               SuperscriptBox["r1", "2"], "+", 
               SuperscriptBox["r2", "2"], "+", 
               SuperscriptBox["r3", "2"]}]], "+", 
             FractionBox[
              RowBox[{"r2", " ", 
               RowBox[{"Sin", "[", 
                SqrtBox[
                 RowBox[{
                  SuperscriptBox["r1", "2"], "+", 
                  SuperscriptBox["r2", "2"], "+", 
                  SuperscriptBox["r3", "2"]}]], "]"}]}], 
              SqrtBox[
               RowBox[{
                SuperscriptBox["r1", "2"], "+", 
                SuperscriptBox["r2", "2"], "+", 
                SuperscriptBox["r3", "2"]}]]]}], ")"}]}]}], ")"}], "3"]}]}]}],
     "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.7207903132757545`*^9, 3.7207903595007544`*^9, 3.7207904259197545`*^9, 
   3.7207917959207544`*^9, {3.7207918511787543`*^9, 3.720791919417754*^9}}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
           TemplateBox[{"1"},
            "OutputSizeLimit`Skeleton",
            DisplayFunction->(FrameBox[
              RowBox[{"\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}],
               Background -> GrayLevel[0.75], 
              BaseStyle -> {
               "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                ShowStringCharacters -> False}, BaselinePosition -> Baseline, 
              ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
              FrameStyle -> None, RoundingRadius -> 7]& )], ",", 
           TemplateBox[{"1"},
            "OutputSizeLimit`Skeleton",
            DisplayFunction->(FrameBox[
              RowBox[{"\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}],
               Background -> GrayLevel[0.75], 
              BaseStyle -> {
               "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                ShowStringCharacters -> False}, BaselinePosition -> Baseline, 
              ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
              FrameStyle -> None, RoundingRadius -> 7]& )], ",", 
           RowBox[{"{", 
            TemplateBox[{"1"},
             "OutputSizeLimit`Skeleton",
             DisplayFunction->(FrameBox[
               
               RowBox[{
                "\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
               Background -> GrayLevel[0.75], 
               BaseStyle -> {
                "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
                 ShowStringCharacters -> False}, BaselinePosition -> Baseline,
                ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
               FrameStyle -> None, RoundingRadius -> 7]& )], "}"}]}], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{65., {3., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{52., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 437, 23047556963260673133, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{62., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 437, 23047556963260673133, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{44., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 437, 23047556963260673133, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{78., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[437]]], "Output",
 CellChangeTimes->{
  3.7207903132757545`*^9, 3.7207903595007544`*^9, 3.7207904259197545`*^9, 
   3.7207917959207544`*^9, {3.7207918511787543`*^9, 3.7207919195067544`*^9}}]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowSize->{1920, 1118},
WindowMargins->{{-8, Automatic}, {Automatic, -8}},
ShowSelection->True,
CellLabelAutoDelete->True,
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> 
     FrontEnd`FileName[{"Report"}, "StandardReport.nb", CharacterEncoding -> 
       "UTF-8"]], Background -> GrayLevel[1]], 
   Cell[
    StyleData["Title"], TextAlignment -> Center, FontColor -> GrayLevel[0]], 
   Cell[
    StyleData["Section"], CellFrameColor -> GrayLevel[0.334844]], 
   Cell[
    StyleData["Input"]]}, Visible -> False, FrontEndVersion -> 
  "11.0 for Microsoft Windows (64-bit) (September 21, 2016)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 326, 4, 72, "Section"],
Cell[CellGroupData[{
Cell[918, 30, 10432, 230, 477, "Input"],
Cell[11353, 262, 1794830, 44726, 32323, "Output"],
Cell[1806186, 44990, 9043, 225, 100, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

